local E, L = unpack(select(2, ...)) -- Engine, Locale
local CO, UF = E:LoadModules("Config", "Unitframes")

--[[--------------------
	Unitframe Extension	
--------------------]]--

local _
local Module = {}

-----------------------------------------

Module.Frames = {}
local Events = {"UNIT_PORTRAIT_UPDATE"}

local function UpdateElement(Element, Unit)
	if Element.Disabled or not UnitExists(Element.Unit) or not UnitIsUnit(Unit, Element.Unit) then return end
	
	E:SetModelInfo(Element, "SetUnit", Element.Unit)
end

local function ForceUpdate(Element)
	UpdateElement(Element, Element.Unit)
end

local function OnEvent(Element, event, ...)
	UpdateElement(Element, ...)
end

----------

function Module:LoadProfile()
	local ProfileTarget
	for _, F in pairs(Module.Frames) do
		
		ProfileTarget = self.db.units[F.ProfileUnit]
		
		if not ProfileTarget.portrait.enable then
			F.Portrait:Hide()
			F.Portrait.Disabled = true
			
			E:SetModelInfo(F.Portrait, "ClearModel")
		else	
			F.Portrait:Show()
			F.Portrait.Disabled = false
			
			F.Portrait:SetAlpha(ProfileTarget.portrait.alpha)
			E:SetModelInfo(F.Portrait, "SetPortraitZoom", ProfileTarget.portrait.zoom)
			E:SetModelInfo(F.Portrait, "SetCamDistanceScale", ProfileTarget.portrait.camDistanceScale)
			E:SetModelInfo(F.Portrait, "SetRotation", ProfileTarget.portrait.rotation)
		end
	end
end

function Module:Create(F)
	F.Portrait = CreateFrame("PlayerModel", nil)
	F.Portrait:SetParent(F)
	F.Portrait:SetAllPoints(F)
	F.Portrait.Unit = F.Unit
	
	F.Portrait:RegisterUnitEvent(Events[1], F.Unit)
	F.Portrait:SetScript("OnEvent", OnEvent)
	
	F.Portrait.CutOffParent = CreateFrame("Frame", nil, F)
	F.Portrait.CutOffParent:SetFrameLevel(F.Health:GetFrameLevel() + 1) -- This way it always is above the Bar
	
	F.Portrait.ForceUpdate = ForceUpdate
	table.insert(Module.Frames, F)
end

---------- Add Module
UF.Modules["Portrait"] = Module